﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq.Expressions;
using System.Windows;

namespace PrvniWPF
{
    public partial class ChangeNotificationSample : Window
    {


        public string Titulek => "AHOJ";

        public ChangeNotificationSample()
        {
            InitializeComponent();
            this.DataContext = this;

            //lbUsers.ItemsSource = users;
        }

        private ObservableCollection<User> users;

        public ObservableCollection<User> Users
        {
            get
            {
                if (users==null)
                {
                    users = new ObservableCollection<User>();

                    users.Add(new User() { Name = "John Doe" });
                    users.Add(new User() { Name = "Jane Doe" });
                }
                return users;
            }
        }


        private void btnAddUser_Click(object sender, RoutedEventArgs e)
        {
            users.Add(new User() { Name = "New user" });
        }

        private void btnChangeUser_Click(object sender, RoutedEventArgs e)
        {
            if (lbUsers.SelectedItem != null)
                (lbUsers.SelectedItem as User).Name = "Random Name";

        }

        private void btnDeleteUser_Click(object sender, RoutedEventArgs e)
        {
            if (lbUsers.SelectedItem != null)
                users.Remove(lbUsers.SelectedItem as User);
        }
    }

    public class User: INotifyPropertyChanged
    {
        private string name;
        public string Name
        {
            get
            {
                return name;
            }

            set
            {
                name = value;
                NotifyPropertyChanged(nameof(Name));   
                NotifyPropertyChanged("FullName");
            }
        }

        //public string FullName
        //{
        //    get
        //    {
        //        return "Pepa " + Name;
        //    }       
        //}

        public string FullName => "Pepa " + Name;

        public event PropertyChangedEventHandler PropertyChanged;

        public void NotifyPropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        //public void OnPropertyChanged<T>(Expression<Func<T>> propertyExpression)
        //{
        //    this.OnPropertyChanged(propertyExpression.Name);
        //}



    }
}